#pragma once

#define TS_CHUNK_SIZE 256

#define DEFAULT_TS_BUFFER_SIZE 15
#define DEFAULT_BCAS_RETRY_COUNT 0
#define DEFAULT_FORCE_RETRY_TS 0
#define DEFAULT_PACKET_FILTERING 2
#define DEFAULT_THREAD_PRIORITY 0
#define DEFAULT_ENABLE_XOR 1
#define DEFAULT_ENABLE_DIGIRADIO 0
#define DEFAULT_ENABLE_REMOCON 1
#define DEFAULT_ENABLE_ANTLV 1
#define DEFAULT_ENABLE_B25DECODE 1
#define DEFAULT_ENABLE_SSE2 1
#define DEFAULT_ENABLE_FIRMALERT 1
#define DEFAULT_BACKEND 0

#define EXPORT_IBONDRIVER


#include "IDyud200.h"
#include "dy-ud200-tools.h"
#include "aescpp.h"
#include "TSfilter.h"
#include "TSDescrambler.h"
#include "oneseg_PAT_Generator.h"
#include "RingBuffer.h"
#include "uusbb_winusb.h"
#include "uusbb_libusb.h"

#pragma warning(push)
#pragma warning(disable: 4995)
#include <queue>
#pragma warning(pop)

#include <boost/pool/pool.hpp>
#include <boost/pool/pool_alloc.hpp>


//Default AES-256 key
const UCHAR pbDefaultKey[32] =
{
    0x75, 0x93, 0xee, 0x38, 0x0d, 0x99, 0x44, 0x95,
    0x9f, 0xc7, 0x67, 0x2c, 0x59, 0xeb, 0x1f, 0x69,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

const UCHAR pbDefalutXORkey[32]=
{
	0xFA, 0x80, 0x09, 0x1A, 0x97, 0xE0, 0x4F, 0xC8,
	0x0A, 0x59, 0xBA, 0xC2, 0xB6, 0xCD, 0x65, 0x2C,
	0xC1, 0x7A, 0xCE, 0xC5, 0x18, 0x42, 0x91, 0x45,
	0xA5, 0x59, 0x7E, 0xA4, 0xD8, 0xB1, 0xCC, 0x83
}; 

//̃pX擾邽߂ɃW[nhۑƂ
DYUD_EXPORT HMODULE hModuleThis;

class cDY_UD200 : public IDY_UD200
{
public:
	cDY_UD200();
	~cDY_UD200();

//IBonDriver
	const BOOL OpenTuner(void);
	void CloseTuner(void);

	const BOOL SetChannel(const BYTE bCh);
	const float GetSignalLevel(void);		//LȒl͋AĂȂA`lT[`prxH

	const DWORD WaitTsStream(const DWORD dwTimeOut = 0);
	const DWORD GetReadyCount(void);

	const BOOL GetTsStream(BYTE *pDst, DWORD *pdwSize, DWORD *pdwRemain);
	const BOOL GetTsStream(BYTE **ppDst, DWORD *pdwSize, DWORD *pdwRemain);

	void PurgeTsStream(void);

	virtual void Release(void);
//IBonDriver2

	LPCTSTR GetTunerName(void);

	const BOOL IsTunerOpening(void);
	
	LPCTSTR EnumTuningSpace(const DWORD dwSpace);
	LPCTSTR EnumChannelName(const DWORD dwSpace, const DWORD dwChannel);

	const BOOL SetChannel(const DWORD dwSpace, const DWORD dwChannel);
	
	const DWORD GetCurSpace(void);
	const DWORD GetCurChannel(void);

//IDY_UD200
	BOOL SendToBCASAndGetResponse(const BYTE* cmd, BYTE cmdsize, BYTE* response, DWORD resmax, DWORD* ressize);
	BOOL GetRemocon(BYTE * ,BYTE);
	DWORD TranslateChannelToFreq(DWORD dwSpace, DWORD dwChannel);
//܂

	DWORD dwLifecounter;
	static cDY_UD200* pThis;

protected:
	AESencrypt DefaultKeyAESencrypt;
	AESdecrypt DefaultKeyAESdecrypt;
	AESencrypt CmdKeyAESencrypt;

	HANDLE hRecvTSThread;
	HANDLE hRecvRemoconThread;

	CRingBuffer<CTSPacket> *ringBufferRecv;

//	CTSPacket* pRecvPackets;
//	DWORD dwTsBufferSize;
//	DWORD dwTsBufferSizeMask;
//	DWORD dwWriteTsBuffer;
//	DWORD dwReadTsBuffer;
	CTSPacketFilter cPacketFilter;
	BYTE GetTsStreamBuffer[TS_CHUNK_SIZE*TS_PACKET_SIZE];

	DWORD dwBCASRetryCount;
	BOOL bForceRetryTs;
	DWORD PacketFiltering;
	DWORD threadPriority;
	BOOL xorCryptedFlag;
	DWORD EnableDigiRadio;
	BOOL EnableRemocon;
	BOOL EnableAntLv;
	BOOL enableB25Decode;
	BOOL enableSSE2;
	BOOL enableFirmAlert;

	UCHAR szTSxorLUT[514];

	CTSDescrambler tsDescrambler;

	DWORD dwAryOverrideFreq[3][64];

	BOOL bTsLock;
	BOOL bTunerLock;
	BOOL bTsRunning;

	IUniversalUSBBackend* usbBackend;
	BYTE usbBackendType;

	DWORD dwCurSpace;
	DWORD dwCurChannel;

	UCHAR uBCAScycle;//B-CASR}hsR}h̒萔A0x000x40JԂ

	//ZO[hPAT
	COnesegPatGenerator onesegPatGen;

	BOOL bLoopThread;

	CRITICAL_SECTION TsCriticalSection;
	CRITICAL_SECTION IoCriticalSection;


	//APIQ
	BOOL Initialize_Device(void);
	BOOL LoadConfiguration(void);

	static DWORD WINAPI RecvRemoconThread(LPVOID pParam);
	static DWORD WINAPI RecvTSThread(LPVOID pParam);

	BOOL SendCommandAndRecvResponse(UCHAR cmd[], int cmdsize, UCHAR res[], int ressize);

	BOOL GetFirmwareVersion(FIRMVERSION* fv);
	BOOL GetSerialnumber(char szSerial[16]);
	UCHAR GetLockStatus(void);

	BOOL SetFrequency(DWORD freq);
	BOOL SetSegMode(DWORD mode);
	BOOL SetSegMode(void);
	BOOL SetTSXorKey(void);
	BOOL SetTSXorKey(UCHAR* key, DWORD keysize);
	BOOL StopTSStreaming(void);
	BOOL StartTSStreaming(void);

	void LockTs(void);
	void UnlockTs(void);
	void LockIo(void);
	void UnlockIo(void);
};
