#include "stdafx.h"
#include "RingBuffer.h"
#include "TSPacket.h"

//Oobt@NXev[g̊e`

template <class T, class U>
CRingBuffer<T,U> CRingBuffer<T,U>::operator<<(T& t)
{
	return this->AddData(t);
}

template <class T, class U>
CRingBuffer<T,U> CRingBuffer<T,U>::operator>>(T* t)
{
	*t = *this->GetData();
	return *this;
}

template <class T, class U>
CRingBuffer<T,U> CRingBuffer<T,U>::operator>>(T** t)
{
	*t = this->GetData();
	return *this;
}

template <class T, class U>
bool CRingBuffer<T,U>::AddData(T& t)
{
	if( ((this->readPtr-this->writePtr)&this->ptrMask) == 1)
		return false;//obt@t

	this->buffer[this->writePtr] = t;

	this->writePtr = (this->writePtr+1)&this->ptrMask;

	return true;
}

template <class T, class U>
T* CRingBuffer<T,U>::GetData(void)
{
	if(this->readPtr == this->writePtr)
		return NULL;

	T* ret = this->buffer+this->readPtr;

	this->readPtr = (this->readPtr+1)&this->ptrMask;
	return ret;
}

template <class T, class U>
U CRingBuffer<T,U>::UsedSize(void)
{
	return (this->writePtr-this->readPtr)&this->ptrMask;
}

template <class T, class U>
U CRingBuffer<T,U>::BufferSize(void)
{
	return this->ptrMask+1;
}

template <class T, class U>
void CRingBuffer<T,U>::Clear(void)
{
	this->readPtr = this->writePtr = 0;
}

template <class T, class U>
CRingBuffer<T,U>::CRingBuffer(unsigned char sizeWithBitWidth)
{
	U size = 1 << sizeWithBitWidth;

	this->ptrMask = size -1;
	this->buffer = new T[size];
	this->readPtr = this->writePtr = 0;
}

template <class T, class U>
CRingBuffer<T,U>::~CRingBuffer()
{
	delete[] this->buffer;
}

//CX^X
template class CRingBuffer<CTSPacket>;