#include "stdafx.h"

#include "TSfilter.h"

void CTSPacketFilter::ParsePacket(CTSPacket& packet)
{
	if(packet.IsEmpty())
	{
		return;
	}
	if(packet.LockByte() != 0x47)
	{
		return;
	}
	if(packet.ErrorBit())
	{
		return;
	}

	//PAT
	if(packet.PID() == 0)
	{
		//CRC`FbN͍̂Ƃ떳
		BYTE* pTable;
		unsigned int nTableSize, nEntry;

		this->PAT.ParsePacket(packet);

		if(this->PAT.IsAccumulated())
		{
			this->PAT.GetSection(&pTable, &nTableSize);

			//e[uʁAPAT0x00
			if(pTable[0] != 0)
			{
				return;
			}

			nEntry = (nTableSize - 5 - 4)>>2;//PATe[uGg[̐
			this->vPMTclear();
			for(unsigned int i=0; i<nEntry; i++)
			{
				if(pTable[8+(i<<2)] + pTable[8+(i<<2)+1] ==0)
					continue;//ԑgԍPIDA0x0010ŌŒ

				WORD pid = ((pTable[8+(i<<2)+2] & 0x1f) <<8) + pTable[8+(i<<2)+3];

				CTSPacketSectionAccumulator* sa;
				sa = new CTSPacketSectionAccumulator;
				sa->SetPID(pid);

				this->vPMT.push_back(sa);
			}
		}

		return;
	}

	//PMTXg̃[v
	for(unsigned int i=0; i<this->vPMT.size(); i++)
	{
		if(this->vPMT[i]->GetPID() != packet.PID())
			continue;//PMTł͂Ȃ

		//CRĈ͍Ƃ`FbNȂ

		BYTE* pTable;
		unsigned int nSectionSize, nPointer;

		this->vPMT[i]->ParsePacket(packet);
		
		if(this->vPMT[i]->IsAccumulated())
		{
			this->vPMT[i]->GetSection(&pTable, &nSectionSize);

			//e[uʁAPMT0x02
			if(pTable[0] != 0x02)
			{
				return;
			}

			this->vvAllowedPIDList[packet.PID()].clear();

			nPointer = 7;
			while(nSectionSize-nPointer > 4)
			{
				WORD pid = ((pTable[nPointer+1]&0x1f)<<8) + pTable[nPointer+2];
				this->vvAllowedPIDList[packet.PID()].push_back(pid);
				//Lqqׂ***************G[ŗƂ*****************
				this->ParseDescriptor(packet.PID(), pTable+nPointer+5, pTable[nPointer+4]);
				nPointer += 5 + pTable[nPointer+4];
			}
		}
	}
	return;
}

bool CTSPacketFilter::CheckAllow(CTSPacket& packet)
{
	if(packet.IsEmpty())
	{
		return false;
	}
	if(packet.LockByte() != 0x47)
	{
		return false;
	}
	if(packet.ErrorBit())
	{
		return false;
	}

	//ŒPIDQ
	switch(packet.PID())
	{
	case 0x0000://PAT
	case 0x0001://CAT
	case 0x0010://NIT
	case 0x0011://SDT,BAT
	case 0x0012://EIT
	case 0x0026:
	case 0x0027:
	case 0x0013://RST
	case 0x0014://TDT,TOT
	case 0x0017://DCT
	case 0x001E://DIT
	case 0x001F://SIT
	case 0x0020://LIT
	case 0x0021://ERT
	case 0x0022://PCAT,SDTT
	case 0x0023://SDTT
	case 0x0028://SDTT
	case 0x0024://BIT
	case 0x0025://NBIT,LDT
	case 0x0029://CDT
		return true;
	case 0x1fff://NULL
		return false;
	}

	for(unsigned int i=0; i<this->vPMT.size(); i++)
	{
		//PMT
		if(this->vPMT[i]->GetPID() == packet.PID())
		{
			return true;
		}

		//vOpPbg
		for(unsigned int j=0; j<this->vvAllowedPIDList[this->vPMT[i]->GetPID()].size(); j++)
		{
			if(this->vvAllowedPIDList[this->vPMT[i]->GetPID()][j] == packet.PID())
				return true;
		}
	}

	//S~pP
	return false;
}

bool CTSPacketFilter::ParseAndCheckAllow(CTSPacket& packet)
{
	this->ParsePacket(packet);
	return this->CheckAllow(packet);
}

//Lqqׂ
bool CTSPacketFilter::ParseDescriptor(WORD cPID, BYTE desc[], WORD size)
{
	WORD nPointer=0;
	WORD pid;

	//PID܂܂ꂽLqqm炻PIDǉ
	while(nPointer<size-1)
	{
		switch(desc[nPointer])
		{
		case 0x09://MLqq
			pid = ((desc[nPointer+4]&0x1f)<<8) + desc[nPointer+5];
			this->vvAllowedPIDList[cPID].push_back(pid);
			if(pid != 0x1fff)
				this->pid_ECM = pid;
			break;
		case 0xc0://Kw`Lqq
			pid = ((desc[nPointer+3]&0x1f)<<8) + desc[nPointer+4];
			this->vvAllowedPIDList[cPID].push_back(pid);
			break;
		case 0xf8://ĐLqq
			pid = ((desc[nPointer+4]&0x1f)<<8) + desc[nPointer+5];
			this->vvAllowedPIDList[cPID].push_back(pid);
			break;
		}
		nPointer += 2 + desc[nPointer+1];
	}
	return true;
}

void CTSPacketFilter::vPMTclear(void)
{
	while(!this->vPMT.empty())
	{
		delete this->vPMT.back();
		this->vPMT.pop_back();
	}
}

void CTSPacketFilter::Clear(void)
{
	this->PAT.SetPID(0);
	this->vPMTclear();
	this->vvAllowedPIDList.clear();
}

bool CTSPacketFilter::IsECM(CTSPacket &packet)
{
	if(this->pid_ECM == 0x1fff)
		return false;
	if(packet.PID() == this->pid_ECM)
		return true;
	return false;
}

CTSPacketFilter::CTSPacketFilter()
{
	this->Clear();
}

CTSPacketFilter::~CTSPacketFilter()
{
}

/*

肩(*L߁`*)

void CTSPacketVector::Push(CTSPacket* packet)
{
	if(!this->lPackets.empty())
	{
		this->nDropPackets += (packet->CyclicNumber() - this->lPackets.back()->CyclicNumber() - 1)&0xf;
	}

	this->lPackets.push_back(packet);
}

void CTSPacketVector::Clear(void)
{
	while(!this->lPackets.empty())
	{
		delete this->lPackets.back();
		this->lPackets.pop_back();
	}
}

CTSPacketVector::CTSPacketVector():nDropPackets(0){}

CTSPacketVector::~CTSPacketVector()
{
	this->Clear();
}

bool CTSPacketParser::AddPacket(CTSPacket* packet)
{
	this->nAllPackets++;

	if(packet->LockByte() != 0x47)
	{
		this->nTruncatedPackets++;
		return false;
	}
	if(packet->ErrorBit())
	{
		this->nTruncatedPackets++;
		return false;
	}

	for(unsigned int i=0; i<this->vFilteringPID.size(); i++)
	{
		if(this->vFilteringPID[i] == packet->PID())
		{
			if(this->mFilteredPackets[packet->PID()].Size() == 0 &&
				!packet->PayloadUnitStart())
			{
				//obt@ŊyC[hjbg̍ŏłȂΎ̂Ă
				//obt@̐擪ɃyC[hjbg̍ŏɂȂɃhbvoÂȂ
				delete packet;
				return true;
			}
			this->mFilteredPackets[packet->PID()].Push(packet);
			return true;
		}
	}

	this->nTruncatedPackets++;
	return false;
}

bool CTSPacketParser::AddPacket(BYTE* packet)
{
	CTSPacket* cP = new CTSPacket;
	if(!cP->AddPacket(packet))
	{
		delete cP;
		return false;
	}

	if(this->AddPacket(cP))
		return true;

	delete cP;
	return false;
}

void CTSPacketParser::Clear(void)
{
	this->mFilteredPackets.clear();
	this->nTruncatedPackets = 0;
	this->nAllPackets = 0;
	this->vFilteringPID.clear();
	this->vFilteringPID.push_back(0);
}

void CTSPacketParser::AddFilteringPID(WORD pid)
{
	for(unsigned int i=0; i<this->vFilteringPID.size(); i++)
	{
		if(this->vFilteringPID[i] == pid)
		{
			return;
		}
	}
	this->vFilteringPID.push_back(pid);
}

void CTSPacketParser::GetFilteringPID(std::vector<WORD>* vPids)
{
	*vPids = this->vFilteringPID;
}

bool CTSPacketParser::IsFilteredPID(WORD pid)
{
	for(unsigned int i=0; i<this->vFilteringPID.size(); i++)
	{
		if(this->vFilteringPID[i] == pid)
			return true;
	}
	return false;
}

unsigned int CTSPacketParser::GetPacketsCount(WORD pid)
{
	if(this->mFilteredPackets.count(pid) == 0)
		return 0;
	return this->mFilteredPackets[pid].Size();
}

unsigned int CTSPacketParser::GetDropPackets(WORD pid)
{
	if(this->mFilteredPackets.find(pid) == NULL)
		return 0;
	return this->mFilteredPackets[pid].DropPackets();
}

unsigned int CTSPacketParser::GetDropPackets(void)
{
	unsigned int ret=0;

	std::map<WORD, CTSPacketVector>::iterator it = this->mFilteredPackets.begin();
	
	while(it != this->mFilteredPackets.end())
	{
		ret += it->second.DropPackets();
		it++;
	}

	return ret;
}

CTSPacketParser::CTSPacketParser():nTruncatedPackets(0),nAllPackets(0),vFilteringPID(1,0)
{}
*/