#include "stdafx.h"

#include "crc32calc.h"

CRC32Calc::CRC32Calc()
{
	unsigned long c;
	int n, k;
	for (n = 0; n < 256; n++)
	{
		c = (unsigned long) n;
		for (k = 0; k < 8; k++)
		{
			if (c & 1)
				c = 0xedb88320L ^ (c >> 1);
			/*0x04C11DB7 / 0xEDB88320 (0x82608EDB)*/
			else
				c = c >> 1;
		}
		this->crc_table[n] = c;
	}
}

unsigned long CRC32Calc::update_crc(unsigned long crc, unsigned char *buf, int len)
{
	unsigned long c = crc;
	int n;

	for (n = 0; n < len; n++) {
		c = crc_table[(c ^ buf[n]) & 0xff] ^ (c >> 8);
	}
	return c;
}

unsigned long CRC32Calc::crc(unsigned char *buf, int len)
{
	return this->update_crc(0xffffffffL, buf, len) ^ 0xffffffffL;
}
