#include "stdafx.h"

#include "oneseg_PAT_Generator.h"


const BYTE COnesegPatGenerator::frame_PAT[] = {
	//TS header
	0x47, 0x60, 0x00, 0x10, 0x00, 
	//					4bit:cyclicCounter

	//Section header
	0x00, 0xf0, 0x11, 0x00, 0x00, 0xc1, 0x00, 0x00, 
	//					|@|e[uʎqg(gX|[gXg[ʎq)
	//			@ZNV 5+4*(Xg[+1)+4

	//PAT tables
	0x00, 0x00, 0xe0, 0x10, //NIT_PID0x0010ŒAԑgԍʎq0x0000Œ
	0x00, 0x00, 0xff, 0xc8, //ZOPMT_PID͌Œ
	//|@|ԑgԍʎq
	0x00, 0x00, 0xff, 0xc9, //0x1fc8-0x1fcf͈̔͂ŁAŏ0x1fc8

	//CRC
	0x00, 0x00, 0x00, 0x00
};

void COnesegPatGenerator::ParsePacket(CTSPacket& packet)
{
	switch(packet.PID())
	{
	case 0x0010:
		//NIT
		this->AddNIT(packet);
		break;
	case 0x1fc8:
	case 0x1fc9:
	case 0x1fca:
	case 0x1fcb:
	case 0x1fcc:
	case 0x1fcd:
	case 0x1fce:
	case 0x1fcf:
		//PMT for oneseg
		this->AddPMT(packet);
		break;
	}
}

void COnesegPatGenerator::AddNIT(CTSPacket& pkt)
{
	BYTE* tbl;

	if(!pkt.PayloadUnitStart())
		return;//NIT̐擪ɂp͖

	tbl = pkt.GetPacket() +5;
	if(tbl[0] != 0x40)
		return;//lbg[NNITe[uł͂Ȃ

	//gX|[gXg[ʎq𒊏o
	this->transportStreamID_BE = *(WORD*)(tbl+8+2+ (((tbl[8]&3)<<8)+tbl[9]) +2);
}

void COnesegPatGenerator::AddPMT(CTSPacket& pkt)
{
	BYTE* tbl;

	if(!pkt.PayloadUnitStart())
		return;//PMT̐擪ɂp͖

	tbl = pkt.GetPacket() +5;
	if(tbl[0] != 0x02)
		return;//PMTe[uł͂Ȃ

	//ԑgԍʎq𒊏o
	this->serviceID[pkt.PID()-0x1fc8] = (tbl[3]<<8)+tbl[4];
}

CTSPacket* COnesegPatGenerator::GetPAT(void)
{
	if(this->transportStreamID_BE == 0)	//gX|[gXg[ʎqs
		return NULL;
	if(this->serviceID[0] == 0)			//ZOT[rXĂȂ
		return NULL;

	//PAT

	BYTE* pkt = this->PAT.GetPacket();

	*(WORD*)(pkt+8) = this->transportStreamID_BE;//gX|[gXg[ʎq

	BYTE strCnt=0;//PATɊ܂߂PID̐
	for(int j=0; j<8; j++)
	{
		if(this->serviceID[j] != 0)
		{
			//ԑgԍʎq
			pkt[17+strCnt*4] = (this->serviceID[j])>>8;
			pkt[18+strCnt*4] = (this->serviceID[j])&0xff;
			//PMT_PID
			pkt[19+strCnt*4] = 0xff;
			pkt[20+strCnt*4] = 0xc8+j;
			strCnt++;
		}
	}

	strCnt++;//NIT

	pkt[7] = 5+ 4*(strCnt) +4;//Xg[

	//CRC32
	BIDWORD crc=CalcTsCrc32(pkt+5, 8+ 4*(strCnt));
	*(DWORD*)(pkt+ 5+8+ 4*strCnt)=crc.GetInvert();

	//JE^
	pkt[3] &= 0xf0;
	pkt[3] |= this->cyclicCounter&0x0f;
	this->cyclicCounter++;

	return &this->PAT;
}

COnesegPatGenerator::COnesegPatGenerator()
:cyclicCounter(0),generated(false),transportStreamID_BE(0)
{
	memset(this->serviceID, 0, sizeof(WORD)*9);//T[rXIDXg̏

	//PATŒlŏ
	this->PAT.AddPacket((BYTE*)COnesegPatGenerator::frame_PAT, sizeof(COnesegPatGenerator::frame_PAT));
}
