#pragma once

#define LOOPBACK_TIMEOUT (100)

#include "Iuusbb.h"

//libusb
#include "libusb.h"

//libusb API ֐|C^typedef
typedef void (__cdecl *PUSB_INIT)(void);
typedef int (__cdecl *PUSB_FIND_BUSSES)(void);
typedef int (__cdecl *PUSB_FIND_DEVICES)(void);

typedef struct usb_bus* (__cdecl *PUSB_GET_BUSSES)(void);

typedef struct usb_dev_handle* (__cdecl *PUSB_OPEN)(struct usb_device*);
typedef int (__cdecl *PUSB_CLOSE)(struct usb_dev_handle*);

typedef int (__cdecl *PUSB_SET_CONFIGURATION)(struct usb_dev_handle*, int);
typedef int (__cdecl *PUSB_CLAIM_INTERFACE)(struct usb_dev_handle*, int);
typedef int (__cdecl *PUSB_RELEASE_INTERFACE)(struct usb_dev_handle*, int);

typedef int (__cdecl *PUSB_BULK_READ)(struct usb_dev_handle*, int, char*, int, int);
typedef int (__cdecl *PUSB_BULK_WRITE)(struct usb_dev_handle*, int, char*, int, int);

//libUsb---------------------------------------------------------------------------------
class CUUSBB_libusb:public IUniversalUSBBackend
{
public:
	//IUniversalUSBBackend methods
	bool Open(const GUID &guid, unsigned short vendorId, unsigned short productId);
	void Close(void);
	bool IsOpened(void);
	
	bool ReadPipe(BYTE pipeId, BYTE* buffer, DWORD bufferSize, DWORD *transferredSize);
	bool WritePipe(BYTE pipeId, BYTE* buffer, DWORD bufferSize, DWORD *transferredSize);

	CUUSBB_libusb();
	~CUUSBB_libusb();

protected:
	//internal methods

	//function pointers
	PUSB_INIT usb_init;
	PUSB_FIND_BUSSES usb_find_busses;
	PUSB_FIND_DEVICES usb_find_devices;
	PUSB_GET_BUSSES usb_get_busses;
	PUSB_OPEN usb_open;
	PUSB_CLOSE usb_close;
	PUSB_SET_CONFIGURATION usb_set_configuration;
	PUSB_CLAIM_INTERFACE usb_claim_interface;
	PUSB_RELEASE_INTERFACE usb_release_interface;
	PUSB_BULK_READ usb_bulk_read;
	PUSB_BULK_WRITE usb_bulk_write;

	//members
	HMODULE dllHandle;

	struct usb_dev_handle* udev;

	bool opened;
};
