// FreqSweeper.cpp : AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
#include "FreqSweeper.h"

#define MAX_LOADSTRING 100

// O[oϐ:
HINSTANCE hInst;								// ݂̃C^[tFCX
TCHAR szTitle[MAX_LOADSTRING];					// ^Cg o[̃eLXg
TCHAR szWindowClass[MAX_LOADSTRING];			// C EBhE NX


typedef IBonDriver* (*PCREATEBONDRIVER)(void);

HMODULE hBonDriver;
PCREATEBONDRIVER pCreateBonDriver;
IDY_UD200* dyud200;

// ̃R[h W[Ɋ܂܂֐̐錾]܂:
INT_PTR CALLBACK	DlgProc(HWND, UINT, WPARAM, LPARAM);

int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
 	// TODO: ɃR[h}ĂB
	hBonDriver = LoadLibrary(_T("BonDriver_dyud.dll"));
	pCreateBonDriver = (PCREATEBONDRIVER)GetProcAddress(hBonDriver, "CreateBonDriver");

	dyud200 = dynamic_cast<IDY_UD200*>(pCreateBonDriver());

	dyud200->OpenTuner();

	DialogBox(hInst, MAKEINTRESOURCE(IDD_DIALOG1), NULL, DlgProc);

	dyud200->CloseTuner();
	dyud200->Release();

	return 0;
}


#define SendMessageDlgItem(x, y, z, w) SendMessage(GetDlgItem(hDlg, (x)), (y), (z), (w))
#define AddList(x, y) SendMessageDlgItem((x), CB_ADDSTRING, 0, (LPARAM)(y))
#define AddEditTextDlgItem(x, y, z) AddEditText(GetDlgItem(hDlg, (x)), (y), (z))

BOOL AddEditText(HWND hWnd, LPCTSTR lpszStr, BOOL bUndo)
{
	SendMessage(hWnd,EM_SETSEL,GetWindowTextLength(hWnd),-1);
	return SendMessage(hWnd,EM_REPLACESEL, bUndo, (LPARAM)lpszStr);
}

INT_PTR CALLBACK DlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	TCHAR szStr[256];
	DWORD dw, CFreq, Length, Step;
	double dSum;

	LPCTSTR sz;

	UNREFERENCED_PARAMETER(lParam);

	switch (message)
	{
	case WM_INITDIALOG:
		dw=0;
		while((sz=dyud200->EnumTuningSpace(dw++)) != NULL)
			AddList(IDC_SPACE, sz);
		SendMessageDlgItem(IDC_SPACE, CB_SETCURSEL, 0, 0);

		dw=0;
		while((sz=dyud200->EnumChannelName(SendMessageDlgItem(IDC_SPACE, CB_GETCURSEL, 0, 0), dw++)) != NULL)
			AddList(IDC_CHANNEL, sz);
		SendMessageDlgItem(IDC_CHANNEL, CB_SETCURSEL, 0, 0);

		_stprintf_s(szStr, _T("%d"),
			dyud200->TranslateChannelToFreq(SendMessageDlgItem(IDC_SPACE, CB_GETCURSEL, 0, 0),
				SendMessageDlgItem(IDC_CHANNEL, CB_GETCURSEL, 0, 0))
		);
		SendMessageDlgItem(IDC_EDITCFREQ, WM_SETTEXT, 0, (LPARAM)szStr);
		SendMessageDlgItem(IDC_EDITLENGTH, WM_SETTEXT, 0, (LPARAM)_T("350"));
		SendMessageDlgItem(IDC_EDITSTEP, WM_SETTEXT, 0, (LPARAM)_T("50"));

		return (INT_PTR)TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDCANCEL)
		{
			EndDialog(hDlg, LOWORD(wParam));
			return (INT_PTR)TRUE;
		}
		if (LOWORD(wParam) == IDSTART)
		{
			SendMessageDlgItem(IDC_EDITCFREQ, WM_GETTEXT, 128, (LPARAM)szStr);
			CFreq = _tcstol(szStr, NULL, 10);
			SendMessageDlgItem(IDC_EDITLENGTH, WM_GETTEXT, 128, (LPARAM)szStr);
			Length = _tcstol(szStr, NULL, 10);
			SendMessageDlgItem(IDC_EDITSTEP, WM_GETTEXT, 128, (LPARAM)szStr);
			Step = _tcstol(szStr, NULL, 10);

			for(DWORD i=CFreq-(Step*(Length/Step +1)); i<CFreq+(Step*(Length/Step +1)); i+=Step)
			{
				dyud200->SetFrequency(i);

				Sleep(2000);
				if(dyud200->GetSignalLevel() == 0.0)
				{
					_stprintf_s(szStr, _T("%6dkHz: Can't receive.\n"), i);
					AddEditTextDlgItem(IDC_EDITRESULT, szStr, 0);
					continue;
				}

				dSum = 0.0;
				Sleep(1000);

				for(int j=0; j<10; j++)
				{
					dSum += dyud200->GetSignalLevel();
					Sleep(100);
				}
				_stprintf_s(szStr, _T("%6dkHz: %6.3lf\n"), i, dSum/10);
				AddEditTextDlgItem(IDC_EDITRESULT, szStr, 0);
			}
			AddEditTextDlgItem(IDC_EDITRESULT,_T("Finish.\n"), 0);
			return (INT_PTR)TRUE;
		}
		if (LOWORD(wParam) == IDC_SPACE)
		{
			if(HIWORD(wParam) == CBN_SELCHANGE)
			{
				while(SendMessageDlgItem(IDC_CHANNEL, CB_GETCOUNT, 0, 0) != 0)
				{
					SendMessageDlgItem(IDC_CHANNEL, CB_DELETESTRING, 0, 0);
				}

				dw=0;
				while((sz=dyud200->EnumChannelName(SendMessageDlgItem(IDC_SPACE, CB_GETCURSEL, 0, 0), dw++)) != NULL)
					AddList(IDC_CHANNEL, sz);
				SendMessageDlgItem(IDC_CHANNEL, CB_SETCURSEL, 0, 0);
				_stprintf_s(szStr, _T("%d"),
					dyud200->TranslateChannelToFreq(SendMessageDlgItem(IDC_SPACE, CB_GETCURSEL, 0, 0),
						SendMessageDlgItem(IDC_CHANNEL, CB_GETCURSEL, 0, 0))
				);
				SendMessageDlgItem(IDC_EDITCFREQ, WM_SETTEXT, 0, (LPARAM)szStr);
			}

		}
		if (LOWORD(wParam) == IDC_CHANNEL)
		{
			if(HIWORD(wParam) == CBN_SELCHANGE)
			{
				_stprintf_s(szStr, _T("%d"),
					dyud200->TranslateChannelToFreq(SendMessageDlgItem(IDC_SPACE, CB_GETCURSEL, 0, 0),
						SendMessageDlgItem(IDC_CHANNEL, CB_GETCURSEL, 0, 0))
				);
				SendMessageDlgItem(IDC_EDITCFREQ, WM_SETTEXT, 0, (LPARAM)szStr);
			}

		}
		break;
	}
	return (INT_PTR)FALSE;
}
